unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ShellApi, StdCtrls, ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    TI_Event: TLabel;
    GroupBox2: TGroupBox;
    TI_DC: TLabel;
    GroupBox3: TGroupBox;
    Icon: TImage;
    IconFile: TEdit;
    Browse: TButton;
    Exit: TButton;
    About: TButton;
    OpenDialog1: TOpenDialog;
    GroupBox4: TGroupBox;
    ToolTip: TEdit;
    SetToolTip: TButton;
    AboutGroupBox: TGroupBox;
    Desk: TLabel;
    Author: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    email: TLabel;
    www: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BrowseClick(Sender: TObject);
    procedure ExitClick(Sender: TObject);
    procedure SetToolTipClick(Sender: TObject);
    procedure wwwClick(Sender: TObject);
    procedure emailClick(Sender: TObject);
    procedure AboutClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   procedure IconCallBackMessage( var Mess : TMessage ); message WM_USER + 100;
   //   ,     , 
   //    -  (   ..)
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var nid : TNotifyIconData;
begin
  //      :
  with nid do  //  ,    
               //TNotifyIconData.
  begin
    cbSize := SizeOf( TNotifyIconData ); //  
    Wnd := Form1.Handle; //   Handle   
                         //     .
    uID := 1;            // 
    uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP; // ,  
                                                  // :
                                                  //,   
                                                  // ().
    uCallbackMessage := WM_USER + 100;            //  , 
                                                  //   
                                                  //   ,
                                                  //  ,   
                                                  //()  
                                                  //- 
    hIcon := Application.Icon.Handle;             //  Handle
                                                  // ()
                                                  //(   
                                                  //  
                                                  //.   
                                                  //   )
    StrPCopy(szTip, ToolTip.Text);                //  
                                                  //,   
                                                  // ToolTip,
                                                  //  
                                                  //.
  end;
  Shell_NotifyIcon( NIM_ADD, @nid );
  //    :)
  // ,     
  //NIM_ADD ( ).
  IconFile.Text:=Application.ExeName;
  //      ,  
  // ():)
  Icon.Picture.Icon:=Application.Icon;
  //     
  // ()   
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var nid : TNotifyIconData;
begin
  with nid do
  begin
    cbSize := SizeOf( TNotifyIconData );
    Wnd := Form1.Handle;
    uID := 1;
    uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
    uCallbackMessage := WM_USER + 100;
    hIcon := Application.Icon.Handle;
    StrPCopy(szTip, ToolTip.Text);
  end;
  Shell_NotifyIcon( NIM_DELETE, @nid );
  //   .     ,
  //   ,     .
  // ,     
  //NIM_DELETE ( ).
end;

procedure TForm1.IconCallBackMessage( var Mess : TMessage );
begin
  case Mess.lParam of
    //     ,   :)
    //       ,  ,
    //  -      :)
    //,          
    // .
    WM_LBUTTONDBLCLK  : TI_DC.Caption   := '   '       ;
    WM_LBUTTONDOWN    : TI_Event.Caption:= '   '          ;
    WM_LBUTTONUP      : TI_Event.Caption:= '   '          ;
    WM_MBUTTONDBLCLK  : TI_DC.Caption   := '    ';
    WM_MBUTTONDOWN    : TI_Event.Caption:= '   '        ;
    WM_MBUTTONUP      : TI_Event.Caption:= '   '        ;
    WM_MOUSEMOVE      : TI_Event.Caption:= ' '                   ;
    WM_MOUSEWHEEL     : TI_Event.Caption:= '  '             ;
    WM_RBUTTONDBLCLK  : TI_DC.Caption   := '   '      ;
    WM_RBUTTONDOWN    : TI_Event.Caption:= '   '         ;
    WM_RBUTTONUP      : TI_Event.Caption:= '   '         ;
  end;
end;

procedure TForm1.BrowseClick(Sender: TObject);
var I   : TIcon;
    nid : TNotifyIconData;
begin
  //    ,     
  //(  ,    )
  //,  :
  if OpenDialog1.Execute then //  
  begin
    I:=TIcon.Create; //  I  TIcon
    I.LoadFromFile(OpenDialog1.Filename); //    
                                          //  ,    
                                          //  
    //    ,   ,   
    //TNotifyIconData     :)
    with nid do
    begin
      cbSize := SizeOf( TNotifyIconData );
      Wnd := Form1.Handle;
      uID := 1;
      uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
      uCallbackMessage := WM_USER + 100;
      hIcon := I.Handle;
      StrPCopy(szTip, ToolTip.Text);
    end;
    Shell_NotifyIcon( NIM_MODIFY , @nid );
    //       ,    
    //  ,      NIM_MODIFY
    //( ).
    Icon.Picture.Icon:=I;
    IconFile.Text:=OpenDialog1.FileName;
    I.Free;
  end;
end;

procedure TForm1.ExitClick(Sender: TObject);
begin
  // . 
  Close;
end;

procedure TForm1.SetToolTipClick(Sender: TObject);
var nid : TNotifyIconData;
begin
  //    :)
  //   ,     .
  //  ()    Icon,
  //    :)
  //     
  // ToolTip (    )
  with nid do
  begin
      cbSize := SizeOf( TNotifyIconData );
      Wnd := Form1.Handle;
      uID := 1;
      uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
      uCallbackMessage := WM_USER + 100;
      hIcon := Icon.Picture.Icon.Handle;
      StrPCopy(szTip, ToolTip.Text);
  end;
  Shell_NotifyIcon( NIM_MODIFY , @nid );
  //..    :)
end;

//  ,     
//    :-)
procedure TForm1.wwwClick(Sender: TObject);
begin
  ShellExecute(Application.Handle,'open','http://delphi.hostmos.ru',nil,nil,0);
end;

procedure TForm1.emailClick(Sender: TObject);
begin
  ShellExecute(Application.Handle,'open','mailto:srustik@rambler.ru',nil,nil,0);
end;

procedure TForm1.AboutClick(Sender: TObject);
begin
  if Form1.Width=250 then
  begin
    Form1.Width:=430;
    About.Caption:='  <<';
  end
  else begin
    Form1.Width:=250;
    About.Caption:='  >>';
  end;
  AboutGroupBox.Visible:=not AboutGroupBox.Visible;
end;

end.
